#include "stdafx.h"
#include <cassert>
#include <fstream>
#include <iostream>
#include <iostream>
#include <boost/smart_ptr.hpp>
#include <boost/algorithm/string.hpp>
#include "tinyxml2.h"
#include "M_ActivityTouchingFishRank.h"
#include "FileEncrypt.h"
std::auto_ptr<M_ActivityTouchingFishRank> M_ActivityTouchingFishRank::msSingleton(nullptr);

int M_ActivityTouchingFishRank::GetCount()
{
	return (int)mMapData.size();
}

const M_ActivityTouchingFishRankData* M_ActivityTouchingFishRank::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

boost::unordered_map<int, M_ActivityTouchingFishRankData>& M_ActivityTouchingFishRank::GetMapData()
{
	return mMapData;
}

void M_ActivityTouchingFishRank::Reload()
{
	mMapData.clear();
	Load();
}

void M_ActivityTouchingFishRank::Load(const std::string& path)
{
	std::ifstream readStream(path, std::ios::binary);
	if (!readStream.is_open())
	{
		assert(false);
		return;
	}
	readStream.seekg(0, std::ios::end);
	int fileSize = readStream.tellg();
	boost::shared_array<char> buffer(new char[fileSize+1]);
	buffer.get()[fileSize] = '\0';
	readStream.seekg(0, std::ios::beg);
	readStream.read(buffer.get(), fileSize);
	readStream.close();
	FileEncrypt::decryptBuffer( buffer, fileSize );
	tinyxml2::XMLDocument xmlDoc;
	auto result = xmlDoc.Parse(buffer.get(), fileSize);
	if (result != tinyxml2::XML_SUCCESS)
	{
		assert(false);
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		assert(false);
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_ActivityTouchingFishRankData data;
		data.mID = element->IntAttribute("ID");
		data.mStartRank = element->IntAttribute("StartRank");
		data.mEndRank = element->IntAttribute("EndRank");
		{
			const char* ItemID = element->Attribute("ItemID");
			std::vector<std::string> vecItemID;
			boost::split(vecItemID, ItemID, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecItemID.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecItemID[i].c_str(), &temp))
				{
					data.mItemID.push_back(temp);
				}
			}
		}
		{
			const char* ItemCount = element->Attribute("ItemCount");
			std::vector<std::string> vecItemCount;
			boost::split(vecItemCount, ItemCount, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecItemCount.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecItemCount[i].c_str(), &temp))
				{
					data.mItemCount.push_back(temp);
				}
			}
		}
		{
			const char* ItemIDDouble = element->Attribute("ItemIDDouble");
			std::vector<std::string> vecItemIDDouble;
			boost::split(vecItemIDDouble, ItemIDDouble, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecItemIDDouble.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecItemIDDouble[i].c_str(), &temp))
				{
					data.mItemIDDouble.push_back(temp);
				}
			}
		}
		{
			const char* ItemCountDouble = element->Attribute("ItemCountDouble");
			std::vector<std::string> vecItemCountDouble;
			boost::split(vecItemCountDouble, ItemCountDouble, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecItemCountDouble.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecItemCountDouble[i].c_str(), &temp))
				{
					data.mItemCountDouble.push_back(temp);
				}
			}
		}
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		assert(mMapData.find(data.mID) == mMapData.end());
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
}

void M_ActivityTouchingFishRank::Load()
{
	Load("../Config/M_ActivityTouchingFishRank.xml");
}

M_ActivityTouchingFishRank* M_ActivityTouchingFishRank::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_ActivityTouchingFishRank());
	}
	return msSingleton.get();
}
